﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.07
@EndOfDesignText@
'Static code module
Sub Class_Globals
	'the vuetify instance	
	Public vuetify As VuetifyApp
	'this route page
	Public page As VueComponent
	'the path to this page
	Public path As String
	'the name of the page, should be unique
	Public name As String = "jsonusers"
	'banano transpiler
	Private banano As BANano			'ignore
	'layout components
	
	Private dlgConfirm As VMsgBox
	Private dlgUsers As VMsgBox
	Private dsUsers As BananoDataSource
	Private dtUsers As VueTable
	Private frmUsers As VForm
	Private txtemail As VField
	Private txtid As VField
	Private txtname As VField
	Private txtphone As VField
	Private txtusername As VField
	Private txtwebsite As VField
	Private VCol1 As VCol
	Private VContainer1 As VContainer
	Private VRow1 As VRow
	Private cboGender As VField
	Private chkActive As VField
	Private btnDoSomething As VField
	Private btnCancel As VField
	Private imgPP As VField
	Private txtDateStarted As VField
	Private txtprogress As VField
	Private txtrating As VField
End Sub

'initializes the page and builds the html structure
Sub Initialize(v As VuetifyApp)						'ignoreDeadCode
	'establish a reference to the app
	vuetify = v
	'initialize the page using unique name
	page.Initialize(Me, name)
	'link the vuetify instance
	page.vuetify = vuetify
	'make this the start page
	page.StartPage
	path = page.path
	'
	'build the page html here
	banano.LoadLayout(page.Here, "jsoncrud")
	
	'bind the form
	frmUsers.BindState(page)	
	
	'bind the form to the other components
	frmUsers.BindDataSource(dsUsers)
	frmUsers.BindDataTable(dtUsers)
	'add this route component to the app
	vuetify.AddRoute(page)
	txtDateStarted.WatchDate(page)
End Sub

'this is executed before the page is entered
'we can check authentication
Sub beforeEnter(boTo As Map, boFrom As Map, boNext As BANanoObject)   'ignoreDeadCode
	vuetify.Loading(True)
	'the page we are going to
	'vuetify.SaveRoute(boTo, False)
	'check authentication
	'If vuetify.Authenticated = False Then
		'user is not authenticated, go to login page
	'	vuetify.NavigateToNext(boNext, "login")
	'	Return
	'End If
	'continue navigation
	vuetify.NavigateToNext(boNext, "")
End Sub


'Use beforeDestroy if you need to clean-up events or reactive subscriptions:	
'Sub beforedestroy		'ignoreDeadCode
'	Log("beforedestroy")
'End Sub

'The updated hook runs after data changes on your component and the DOM re-renders.
'Sub updated			'ignoreDeadCode
'	Log("updated")
'End Sub

'The beforeUpdate hook runs after data changes on your component and the update cycle begins, right before the DOM is patched and re-rendered.
'Sub beforeupdate		'ignoreDeadCode
'	Log("beforeupdate")
'End Sub

'The beforeMount hook runs right before the initial render happens and after the template or render functions have been compiled:
'Sub beforemount		'ignoreDeadCode
'	Log("beforemount")
'End Sub

'The beforeCreate hook runs at the very initialization of your component. data has not been made reactive, and events have not been set up yet
'Sub beforecreate		'ignoreDeadCode
'	Log("beforecreate")
'End Sub

'You are able to access reactive data and events that are active with the created hook.
'Templates and Virtual DOM have not yet been mounted or rendered:
Sub created		'IgnoreDeadCode
	'Log("created")
	'Dim csvData As String = banano.Await(banano.GetFileAsText("./assets/file.csv", Null, "utf8"))
	'Log(csvData)
	'Dim csv As Map = banano.Await(vuetify.PapaParseCSV(csvData, ",", True, True))
	'Log(csv)
End Sub

'changes the text-color
Sub GenderColor(item As Map) As String
	'get the gender
	Dim sgender As String = item.Get("gender")
	'depending on the gender return the text color to apply to the gender
	Select Case sgender
	Case "Male"
		Return page.BuildTextColor(vuetify.COLOR_BLUE, vuetify.INTENSITY_NORMAL)
	Case Else '"Female"		
		Return page.BuildTextColor(vuetify.COLOR_PINK, vuetify.INTENSITY_NORMAL)
	End Select
End Sub

'changes the backgriund color
Sub NameStyle(item As Map) As Map
	'read the rating
	Dim irating As Int = item.GetDefault("rating", 0)
	'ensure its a int
	irating = banano.parseInt(irating)
	'define style depending on the rating
	Dim s As Map = CreateMap()
	Select Case irating
	Case 1	
		s.Put("backgroundColor", vuetify.COLOR_BLUE)
		s.Put("color", vuetify.COLOR_WHITE)
		s.Put("fontSize", "24px")
	Case 2
		s.Put("backgroundColor", vuetify.COLOR_AMBER)
	Case 3
		s.Put("backgroundColor", vuetify.COLOR_BROWN)
		s.Put("color", vuetify.COLOR_WHITE)
	Case 4
		s.Put("backgroundColor", vuetify.COLOR_CYAN)
	Case 5		
		s.Put("backgroundColor", vuetify.COLOR_GREEN)
	End Select
	Return s
End Sub


Sub mounted
	vuetify.Loading(False)
	dtUsers.UpdateLoading(True)
	dsUsers.SELECT_ALL
End Sub

'the result of dsUsers.SELECT_ALL
Sub dsUsers_SelectAll (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
	If Success And Response = dsUsers.RESULT_SUCCESS Then
		'reload records to the data-table
		dtUsers.Reload(Result)
		'turn off table loading indicator
		dtUsers.UpdateLoading(False)
	Else
    	Log(Error)
   	 	dtUsers.UpdateLoading(False)
    	vuetify.ShowSwalError("The operation could not be executed, please try again!")
	 	Return
	End If
End Sub


'In the mounted hook, you will have full access to the reactive component, templates, and rendered DOM
Sub old_mounted		'ignoreDeadCode
	'show an loading indicator on the data-tab;e
	dtUsers.UpdateLoading(True)
	'lets use data from the API
	Dim axios As BANanoAxios
	'initialie axios with the base url
	axios.Initialize("https://jsonplaceholder.typicode.com/users")
	'execute an asycn get
	Dim users As List = banano.Await(axios.GetAllWait)
	Dim bf As BANanoFakeIT
	bf.Initialize
	'add gender
	Dim uTot As Int = users.Size - 1
	Dim uCnt As Int = 0
	For uCnt = 0 To uTot
		Dim user As Map = users.Get(uCnt)
		Dim ng As String = bf.Rand_Gender
		user.Put("gender", ng)
		'let add active indicators
		user.Put("active", bf.Rand_Yes_Or_No)
		user.Put("rating", Rnd(1, 5))
		user.Put("progress", Rnd(0, 150))
		user.Put("profilepic", bf.Rand_ProfilePic)
		user.Put("datestarted", bf.Rand_Date)
		user.Put("color", bf.Rand_Color)
		users.Set(uCnt, user)
	Next
	'save to json
	'Dim xJSON As String = banano.ToJson(users)
	'page.Download(xJSON, "users.json")
	'load the users to the data-table
	dtUsers.Reload(users)
	'hide the laoding indicator
	dtUsers.UpdateLoading(False)
End Sub

'Use destroyed if you need do any last-minute cleanup or inform a remote server that the component was destroyed:
'Sub destroyed		'ignoreDeadCode
'	Log("destroyed")
'End Sub

Private Sub btnDoSomething_Click (e As BANanoEvent)
	vuetify.ShowSnackBarSuccess("Do something!")
End Sub

'when the data-table add button is clicked
Private Sub dtUsers_Add_Click (e As BANanoEvent)
	'data source should clear the form contents
	'and set default values
	dsUsers.ADD
	
	'change the title of the dialog
	dlgUsers.Title = $"Add ${(dsUsers.Singular)}"$
	'change the ok label
	dlgUsers.OkLabel = "Save"
	'change the cancel label
	dlgUsers.CancelLabel = "Cancel"
	'show the dialog
	dlgUsers.Show
End Sub

'the ok button has been clicked to add/update a user
Private Sub dlgUsers_Ok_Click (e As BANanoEvent)
   'check permissons
	'If UserProfile.canadd = 0 Then
	'	vuetify.ShowSwalError("You do not have permissons for this action!")
	'	Return
	'End If
	'update the modifield content
	'txtmodified.SetDateTimeNow(component)
	'txtmodifieduserid.setvalue(component, UserProfile.id)

   'perform datasource verification
   dsUsers.VERIFY
   'peform the form validation
	page.refs = vuetify.GetRefs
	Dim bValid As Boolean = frmUsers.Validate(page)
	If bValid = False Then
		'the validation has failed
		vuetify.ShowSwalToastError("Please enter all required information!", 2000)
		Return
	End If
	
	'show a loading indicator on the ok button
	dlgUsers.OkLoading = True
	'get the record from form (recordsource) and CREATE / UPDATE record depending on mode
	dsUsers.CREATE_OR_UPDATE
End Sub

'result of dsUsers.CREATE_OR_UPDATE (CREATE)
Private Sub dsUsers_Create (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
'turn off the ok loading indicator
dlgUsers.OkLoading = False
If Success And Response = dsUsers.RESULT_SUCCESS Then
	'hide the dialog
    dlgUsers.hide
	'run any method to load the records
	page.callmounted
Else
	 Log(Error)
    vuetify.ShowSwalError("The operation could not be executed, please try again!")
	 Return
End If
End Sub

'result of dsUsers.CREATE_OR_UPDATE (UPDATE)
Private Sub dsusers_Update (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
'turn off the loading indicator
dlgUsers.OkLoading = False
If Success And Response = dsUsers.RESULT_SUCCESS Then
	'hide the dialog
    dlgUsers.hide
	'run the method to load records
	page.callmounted
Else
	 Log(Error)
    vuetify.ShowSwalError("The operation could not be executed, please try again!")
	 Return
End If
End Sub

'cancel the user addition
Private Sub dlgUsers_Cancel_click (e As BANanoEvent)
	'hide the dialog
	dlgUsers.hide
	'this is specicif to the JSON db engine
	page.CallMounted
End Sub

Private Sub dtUsers_CancelItem (item As Map)
	
End Sub

Private Sub dtUsers_Change (item As Map)
	
End Sub

Private Sub dtUsers_ClearSort_Click (e As BANanoEvent)
	'clear the sorts in the columns
	dtUsers.ClearSort
End Sub

Private Sub dtUsers_CloseItem (item As Map)
	
End Sub

'delete button click on table
Private Sub dtUsers_Delete (item As Map)
	'add code to handle deletes
	'we want the user to confirm the delete
	dsUsers.DELETE_CONFIRM(item)
	
	Dim sMsg As String = $"<h2>${dsUsers.DisplayValue}</h2><br>Are you sure that you want to delete this ${dsUsers.Singular.ToLowerCase}?"$
	dlgConfirm.Confirm(page, "delete", "Confirm Delete", sMsg, "Yes", "No")
End Sub

'when the confirm button is clicked
Private Sub dlgConfirm_Ok_Click (e As BANanoEvent)
	'we are not using database yet
   'show a loading indicator on ok button
	dlgConfirm.OkLoading = True
   'execute the delete call
	dsUsers.DELETE
End Sub

'result of dsUsers.DELETE and confirm_ok_click
Private Sub dsUsers_Delete (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
dlgConfirm.OkLoading = False
If Success And Response = dsUsers.RESULT_SUCCESS Then
    'hide the dialog
    dlgConfirm.hide
	 'load the method to load all records
    page.callmounted
Else
    Log(Error)
    vuetify.ShowSwalError("The operation could not be executed, please try again!")
	 Return
End If
End Sub


'end user cancels the dialog
Private Sub dlgConfirm_Cancel_click (e As BANanoEvent)
   'hide the dialog
	dlgConfirm.hide
	'this is specicif to the JSON db engine
	page.CallMounted
End Sub

'clicking edit user on the data-table
Private Sub dtUsers_Edit (item As Map)
	'when a user clicks edit, show the item
	'read source from data-table content
	'this does not execute a read from a database-
	dsUsers.EDIT(item)
	dtUsers.UpdateLoading(True)
End Sub

'result of dsUsers.EDIT(item)
'show a loading indicator for the data-table
'set the selected record to be active on the data-source and read from database
'we will show the edit dialog when the record is read from the db
Private Sub dsUsers_Read (Success As Boolean, Response As String, Error As String, affectedRows As Int, Result As List)
	dtUsers.UpdateLoading(False)
	If Success And Response = dsUsers.RESULT_SUCCESS Then
		'move to the first record
		dsUsers.MOVE_FIRST(Result)
		'change the title of the dialog
		dlgUsers.Title = $"Edit ${(dsUsers.Singular)}"$
		'change the ok label
		dlgUsers.OkLabel = "Update"
		'change the cancel label
		dlgUsers.CancelLabel = "Cancel"
		'show the dialog
		dlgUsers.Show
	Else
		Log(Error)
    	vuetify.ShowSwalError("The operation could not be executed, please try again!")
		Return
	End If
End Sub

'when the edit-dialog is opened
Private Sub dtUsers_OpenItem (item As Map)
	
End Sub

'when the data-table refresh is clicked
Private Sub dtUsers_Refresh_Click (e As BANanoEvent)
	'lets mount the contents again
	page.RunMethod("mounted", Null)
End Sub

'when the ok button is clicked on edit dialog
Private Sub dtUsers_SaveItem (item As Map)
	
End Sub

Private Sub btnCancel_Click (e As BANanoEvent)
	'we have removed the action buttons
	dlgUsers.hide
End Sub

'For dates a watch Is established, lets format the date
Private Sub txtDateStarted_Watch
	'dtUsers.SetColumnDateFormat(txtDateStarted, "DD-MMM-YYYY")
	'.DateDisplayFormat("datestarted", "dd/mm/yyyy")
	'page.FormatDisplayDate("txtDateStarted", "dd/mm/yyyy")
	Log("txtDateStarted " )
	'txtDateStarted.FormatDate(page)
End Sub

Private Sub dtUsers_ClearFilter_Click (e As BANanoEvent)
	dtUsers.ClearFilter
End Sub

Private Sub dtUsers_Filter_Click(e As BANanoEvent)
	dtUsers.Filter
End Sub